#!/usr/bin/perl
#  ------------------------------------------
#  poll.pl  -  Polling de Servidores  
#                                           
#   uso: poll.pl                      
#                                          
#  Cria uma conexo TCP com cada um dos 
#  servidores descritos no arquivo 
#  /root/lvs/var/polling, na porta 2357, e
#  altera seus pesos na tabela LVS de acordo
#  com seus usos do processamento, obtidos nas
#  respostas.
#  ------------------------------------------

use IO::Socket;

$path = '/root/lvs/var';

open(INFILE, "$path/polling");
@servers = <INFILE>;
close(INFILE);

@ipvsadm = `ipvsadm -l -n`;

foreach $line (@servers) {
    @line = split(/ /, $line);
    $service = shift(@line);
    %servers = @line;

    my $max = 1;
    foreach $server (keys %servers) {
	&read_uptime($server) unless (&contains($server));
	$servers{$server} *= $uptimes{$server};
	$max = $servers{$server} if ($servers{$server} > $max);
    }

    foreach $server (keys %servers) {
	$servers{$server} = 10 - $servers{$server} * 9 / $max;
	&execute($server, $service, $servers{$server});
    }
}

sub read_uptime {
    my $sock = new IO::Socket::INET (
				     PeerAddr => $_[0],
				     PeerPort => '2357',
				     Proto => 'tcp',
				     ) or die "Could not create bla bla\n";
    $uptimes{$_[0]} = (split(/,/, (split(/load average:/, <$sock>))[1]))[0];
    close($sock);
}

sub contains {
    foreach my $iline (keys %uptimes) {
	return 1 if ($_[0] eq $iline);
    }
}    

sub execute {
    my @portService = split(/:/, $_[1]);
    foreach my $iline (@ipvsadm) {
	if ($iline =~ /$_[0]:$portService[1]/) {
	    if ($portService[0] eq "tcp") {
# print "ipvsadm -e -t 192.168.45.26:$portService[1] -r $_[0] -g -w $_[2]\n";
		system("ipvsadm -e -t 192.168.45.26:$portService[1] -r $_[0] -g -w $_[2]\n");
	    }
	    elsif ($portService[0] eq "udp") {
# print "ipvsadm -e -t 192.168.45.26:$portService[1] -r $_[0] -g -w $_[2]\n";
		system("ipvsadm -e -t 192.168.45.26:$portService[1] -r $_[0] -g -w $_[2]\n");
	    }
	    else {
		print "Protocolo nao reconhecido" and die;
	    }
	}
    }
}
