#!/usr/bin/perl
# ------------------------------------------
# uptimesrv.pl  -  Uptime Server daemon  
#                                          
#  uso: uptimesrv.pl                      
#                                         
# Cria um daemon que responde o uptime da
# maquina local para qualquer requisio 
# TCP na porta 2357                      
# ------------------------------------------
 
use IO::Socket::INET;
use strict;
use POSIX qw(setsid);
use LWP::Simple;

$| = 1;
print "Uptime Server listening\n";

&daemonize;

my $port = 2357;
my $socket = IO::Socket::INET->new('LocalPort' => $port,
				   'Proto' => 'tcp',
				   'Listen' => SOMAXCONN)
    or die "Can't create socket ($!)\n";

while (my $client = $socket->accept) {
#    my $name = gethostbyaddr($client->peeraddr, AF_INET);
#    my $port = $client->peerport;

    my $uptime = qx("uptime");
    print $client "$uptime";

    close $client 
        or die "Can't close ($!)\n";
}
die "Can't accept socket ($!)\n";


sub daemonize {
    chdir '/' or die "Can't chdir to /: $!";
    open STDIN, '/dev/null' or die "Can't read from /dev/null: $!";
    open STDOUT, '>>/dev/null' or die "Can't write to /dev/null: $!";
    open STDERR, '>>/dev/null' or die "Can't write to /dev/null: $!";
    defined (my $pid = fork) or die "Can't fork: $!";
    exit if $pid;
    setsid or die "Can't start a new session: $!";
    umask 0;
}
